/*
This file is part of ObjetcsOS.

ObjetcsOS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

ObjetcsOS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ObjectsOS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "types.h"

void copydata(char* s, char* d, DWORD len)
{
        while(len) {
                len--;
                *d = *s;
                s++;
                d++;
        }
}

void movedata(unsigned ssel, unsigned s, unsigned dsel, unsigned d, unsigned len)
{
        asm(
        "pushw %%ds\n"
        "pushw %%ax\n"
        "popw  %%ds\n"
        "pushw %%es\n"
        "pushw %%bx\n"
        "popw  %%es\n"
        "moveloop: \n"
        "lodsb     \n"
        "stosb     \n"
        "loop moveloop\n"
        "popw   %%es\n"
        "popw   %%ds"
        ::"a" (ssel), "b" (dsel), "D" (d), "S" (s), "c" (len));
}

void fillchar(char* d, char val, unsigned len)
{
        while(len) {
                *d = val;
                d++;
                len--;
        }
}

char _hexbuf[11];

char *inttohex(unsigned num)
{
        BYTE i=9;
        fillchar(_hexbuf, '0', 9);
        _hexbuf[10] = 0;
        while(i) {
                _hexbuf[i] = num % 16;
                num = num / 16;
                if(_hexbuf[i] >= 0xA) _hexbuf[i] += 'A'-10;
                else _hexbuf[i] += '0';
                i--;
        }
        while(_hexbuf[i] == '0') i++;
        if(i == 10) i--;
        _hexbuf[i-2] = '0';
        _hexbuf[i-1] = 'x';
        return _hexbuf+i-2;
}

char _intbuf[11];

char *inttostr(unsigned num)
{
        BYTE i=9;
        fillchar(_intbuf, '0', 9);
        _intbuf[10] = 0;
        while(i) {
                _intbuf[i] = num % 10;
                num = num / 10;
                _intbuf[i] += '0';
                i--;
        }
        while(_intbuf[i] == '0') i++;
        if(i == 10) i--;
        return _intbuf+i;
}
