/*
This file is part of ObjetcsOS.

ObjetcsOS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

ObjetcsOS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ObjectsOS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _oos_include_screen_h
#define _oos_include_screen_h

#include "types.h"

#define TABWIDTH        8

typedef struct {
        char x, y, resx, resy, color;
} SCREEN;

void scrollscreen();
void writeln(char *string);
void write(char* string);
void setCursor(char x, char y);
char getBGColor();
void simulTab();
void gotoXY(BYTE x, BYTE y);

#endif
